
CON
 '' wifi tester by Jim Meek

 '' This program interacts with Propeller keyboard/VGA and Propeller Terminal at the same time.
 '' Local/Terminal commands are: ?=Redisplay Help Screen / !=Test/Display Bluetooth Firmware

  _xinfreq      = 5_000_000      
  _clkmode      = xtal1 + pll16x   

  W_TX_PIN     = 2          '' Change I/O for connection to W TX Pin.
  W_RX_PIN     = 3          '' Change I/O for connection to W RX Pin.
  W_BAUD       = 57600      '' 
  VG_PIN        = 16
  KB_PIN        = 26
'  TERM_BAUD     = 115200
  Pin           =20
  Pin2          =21
  LED_Pin       =24
  _clockDataPin = 1
  _clockClockPin =0
  _clock_int_Pin =7
  ALTITUDE      =1817
  out           =1
  in            =0
  on            =1
  off           =0
  CR            =$0D
  LF            =$0A
  Null          = $00
  Qmark         = $3F
  FSlash         = $2F       '' /
  BSlash        = $5C        ''\
  US_001 = 80_000_000 / 1_000_000                            ' 5us                        ' 

OBJ
  text        : "VGA_HiRes_Text_Terminal"  
'  kbd         : "comboKeyboard"
  web         : "FullDuplexSerial_2k_051414"
  str         : "ASCII0_STREngine"
  bar         : "29124_altimeter"
  rtc         : "DS3231_RTCEngine_61614"
VAR

  long stringPointer
  long webstack[64]
  word count
  byte term  
  byte stringBuffer[64]
  byte stringBuffer2[64]
  byte temp_str[20]
 
PUB main | rxb, rxc, key,index ,s,t,x,y,sp,p,cm,deg,character
  text.start(VG_PIN) 
'  kbd.start(KB_PIN)
  web.start(W_TX_PIN,W_RX_PIN,%0000,W_BAUD)         '' Serial web Module
  rtc.rtcEngineStart(_clockDataPin, _clockClockPin, -1)
  web.rxflush
  web.txflush
  bar.start(bar#MOBO_B, bar#BACKGROUND)
  dira[_clock_int_pin]~
  dira[LED_Pin]~~
      
  cognew (webthread,@webstack)
  repeat
    programDate
    waitcnt(US_001*950)
PUB programDate |a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,time_pointer,year[5]



    ifnot(rtc.readTime)
      abort text.str(string("Operation Failed", LF))
    result:=str.stringcopy(@Time_info,lookup(rtc.clockDay: string("Sunday"), {
                                          } string("Monday"), {
                                          } string("Tuesday"),  {
                                          } string("Wednesday"), {
                                          } string("Thursday"), {
                                          } string("Friday"), {
                                          } string("Saturday")))
    a:=strsize(result)
    result:=str.stringcopy(@time_info+a,string(", "))
    result:=str.stringcopy(@time_info+a+2,lookup(rtc.clockMonth: string("January"), {
                                            } string("Feburary"), {
                                            } string("March"), {
                                            } string("April"), {
                                            } string("May"), {
                                            } string("June"), {
                                            } string("July"),  {
                                            } string("August"), {
                                            } string("September"), {
                                            } string("October"), {
                                            } string("November"), {
                                            } string("December")))
    b:=strsize(result)                                       
    time_pointer:=a+b+2
    result:=str.stringcopy(@time_info+time_pointer,string(" "))
    time_Pointer++
    c:=@time_info + time_Pointer
    d:=upper_nibble(rtc.clockDate)
    bytefill(c,d,1)
    c++
    e:=lower_nibble(rtc.clockDate)
    bytefill(c,e,1)
    c ++
    
    result:=str.stringcopy(c,string(", "))
    c+=2
    year:=str.integerToDecimal(rtc.clockyear,4)
    year++
    result:=str.stringcopy(c,year)

    text.str(string(" year  "))
    text.str(year)  
    c+=4
    text.str(string("  "))
    c ++
    d:=upper_nibble(rtc.clockMeridiemHour)
    bytefill(c,d,1)
    c++
    result:=str.stringcopy(c,string(" "))
    c++
    e:=lower_nibble(rtc.clockMeridiemHour)
    bytefill(c,e,1)
    c ++
    text.out(e)
    text.str(string("  "))
    result:=str.stringcopy(c,string(":"))
    c++
    d:=upper_nibble(rtc.clockMinute)
    bytefill(c,d,1)
    c++
    e:=lower_nibble(rtc.clockMinute)
    bytefill(c,e,1)
    c ++
    result:=str.stringcopy(c,string(":"))
    c++
    d:=upper_nibble(rtc.clockSecond)
    bytefill(c,d,1)
    c++
    e:=lower_nibble(rtc.clockSecond)
    bytefill(c,e,1)
    c ++
    result:=str.stringcopy(c,string("  "))
    c+=2


    result:=str.stringcopy(c,string(":"))
    c++
    if(rtc.clockMeridiemTime)
      result:=str.stringcopy(c,string("PM", cr,lf))
    else
    
      result:=str.stringcopy(c,(string("AM",cr,lf)))
    text.str(@time_info)
    
      

Pri upper_nibble(PARM)|temp    
    temp:=Parm &$F0
    temp:=temp>>4  + $30
    return temp

Pri Lower_nibble(Parm)|temp
    temp:=Parm &$0F + $30
    return temp
          
PUB webthread
   dira [Pin] ~~
   dira [Pin2]~~

   Repeat
      web_check      
      String_parse
      web.rxflush {
      text.str(string("contents of stringbuffer2 "))
      text.str(string(cr,lf))
      text.str(@Stringbuffer2)
'      text.str(string(cr,lf)) }

      web.str(string(cr,lf))
'      web.str(@Page_header)

      ifnot str.stringCompareCI(@StringBuffer2,@ControlString0)
         command0
      ifnot str.stringCompareCI(@StringBuffer2,@ControlString1)
         command1
      ifnot str.stringCompareCI(@StringBuffer2,@controlString2 )
         command2
      ifnot str.stringCompareCI(@StringBuffer2,@controlString3)
         command3
      ifnot str.stringCompareCI(@StringBuffer2, @controlString4)
         command4  
'      else
       
'         web.str(string("<html><body> IF YOU HAVE REACHED THIS PAGE YOU DON'T BELONG, GET OUT!!!"))
      waitcnt((clkfreq/1000*500) + cnt)
      web.rxflush

PRI web_check   |rxb
      repeat   
        rxb := web.rxcheck
          if rxb <> -1                
'                text.out(rxb)
                str.buildString(rxb)
           
      while((rxb <> CR) and (rxb <> LF) and (rxb <> NULL))
      web.rxflush

Pri String_Parse |String_Start,String_end,String_len,x
      StringPointer :=str.trimString( str.builtString(true))
      String_start:= STR.FindCharacter(StringPointer,FSlash)
      String_start++ 
      str.stringCopy(@StringBuffer,String_start)
      String_end:= STR.FindCharacter(@Stringbuffer,FSlash)
      string_len:=String_end - @stringBuffer 
      bytefill(@StringBuffer2,Null,String_len)
      bytemove(@StringBuffer2,@Stringbuffer,String_len-5)
      Return @StringBuffer2


PRI Command0   | x,y       'power=0
    
      outa[pin]:=off
      web.str(@Page_header)
      x:=ina[pin]
      if x==on
         web.str(@Power_on1)
      else
        web.str(@Power_off1)
      
      Y:=ina[pin2]
      if Y==on
        web.str (@Power_on2)
      else
        web.str (@Power_off2)

      web.str(@Page_body)
      weatherCommand
      return
PRI Command1 |x,y      'power=1
      outa[pin]:=on 'Turn On power on Pin
      web.str(@Page_header)
      x:=ina[pin]
      if x==on
         web.str(@Power_on1)
      else
        web.str(@Power_off1)
      
      Y:=ina[pin2]
      if Y==on
        web.str (@Power_on2)
      else
        web.str (@Power_off2)
      web.str(@Page_body)
      weatherCommand
      return

PRI Command2  |x,y   'power=2


      outa[pin2]:=off 'Turn off power on Pin 2
      web.str(@Page_header) 
       x:=ina[pin]
      if x==on
         web.str(@Power_on1)
      else
        web.str(@Power_off1)
      
      Y:=ina[pin2]
      if Y==on
        web.str (@Power_on2)
      else
        web.str (@Power_off2)
     web.str(@Page_body) 
      weatherCommand
      Return

PRI Command3 |x,y    'Power = 3
  
      outa[pin2]:=on 
      web.str(@Page_header)
      x:=ina[pin]
      if x==on
         web.str(@Power_on1)
      else
        web.str(@Power_off1)
      
      Y:=ina[pin2]
      if Y==on
        web.str (@Power_on2)
      else
        web.str (@Power_off2)

      web.str(@Page_body)

      weatherCommand
      Return

PRI Command4  |s,t

      web.str(@Page_header) 
 
      s:=ina[pin]
      if s==on
        web.str(@Power_on1)
      else
        web.str(@Power_off1)
      t:=ina[pin2]
        if t==on
          web.str(@Power_on2)
        else
          web.str(@Power_off2)
      web.str(@Page_body)
      weatherCommand
      return
      
PRI weatherCommand | sp,deg,p,cm,String_start
      cm := bar.m_from_ft(ALTITUDE * 100)                       ' Convert altitude in feet to cm.
      bar.pause
      p := bar.average_press                                  ' Get the average pressure.
      sp := bar.sealevel_press(p, cm)                         ' Convert to equivalent sea-level pressure, given altitude.
      deg :=bar.current_temp
      bar.resume
      str.stringcopy (@temp_str,(bar.formatn(sp,bar#TO_INCHES,8)))
      text.str(@temp_str)
      web.str(@pressure)
      web.str(@temp_str)
      web.str(@Line_break)
      str.stringcopy (@temp_str,(bar.formatn(deg,bar#TO_DEGF,8)))      
      web.str(@temperature)
      web.str(@Temp_str)
      web.str(@Line_break)
      text.str(@temp_str)

      text.str(string(cr,lf))

      return

DAT
                 byte 0 
 ControlString0  byte "control.htm?Power=0"
                 byte 0 
 ControlString1  byte "control.htm?Power=1"
                 byte 0 
 ControlString2  byte  "control.htm?Power=2"
                 byte 0 
 ControlString3  byte  "control.htm?Power=3"
                 byte 0 
 ControlString4  byte "control.htm?"
                 byte 0 
  
 Page_header  byte "<html> <head > <meta content=",34,"text/html; charset=ISO-8859-1",34
              byte"http-equiv=",34,"Content-Type",34,"><title>Jim's server</title></head>"
              byte" <body bgcolor=",34,"Green",34, ">" 
              byte" <h1 align=",34,"center",34,">Jim's Home Control and weather System</h1><br><br>"
              byte 0
  Power_on1    byte " <div align=" ,34,"center",34,"> <pre> <font size=",34,"+2",34,">   Printer Power is On  "
              byte 0     
 Power_off1   byte " <div align=",34,"center",34,"> <pre> <font size=",34,"+2",34,">   Printer Power is Off "
              byte 0     
 Power_on2    byte "  Main Power is On <BR><BR></pre></font></div>"
              byte 0     
 Power_off2   byte "  Main Power is Off <BR><BR></pre></font></div>"
              byte 0     

 Page_body    byte "<div align=",34,"center",34,"> <pre> <font size=",34,"+2",34,"> Press Buttons to toggle power<br><form>"
              byte "<pre> <font size=",34,"+2",34,"><pre>"
              byte"<input type=  radio name=Power value=1 />  Printer Power On "     ' <br /
              byte"<input type=  radio name=Power value=0 />  Printer Power Off <br /></pre><font>  "
              byte "<input type=  radio name=Power value=3 /> Main Power On "    '<br />
              byte"<input type=  radio name=Power value=2 />  Main Power Off  "
              byte"<form><BR>" 
              byte"<form><BR>" 
              byte"<input type=submit />"   
              byte 0
 Pressure     Byte  "<div align=",34,"center",34,"> <pre> <font size=",34,"+2",34,">Sea Leval Pressure ="
              Byte 0
 Temperature  Byte  "<div align=",34,"center",34,"> <pre> <font size=",34,"+2",34,">Indoor Temperature ="
              Byte 0
 Line_break   Byte "<form><BR>"           
              'byte 0
 Time_info    Byte "                                             "
              Byte 0 
           